<?php

class ForumWatch_DataWriter_ForumWatch extends XenForo_DataWriter
{
	protected function _getFields()
	{
		return array(
				'xf_forum_watch' => array(
						'user_id'          => array('type' => self::TYPE_UINT,    'required' => true),
						'forum_id'        => array('type' => self::TYPE_UINT,    'required' => true),
						'reply_subscribe'  => array('type' => self::TYPE_UINT, 'default' => 0),
						'notification_method'  => array('type' => self::TYPE_UINT, 'default' => 0),
				)
		);
	}

	protected function _getExistingData($data)
	{
		if (!is_array($data))
		{
			return false;
		}
		elseif (isset($data['user_id'], $data['forum_id']))
		{
			$userId = $data['user_id'];
			$forumId = $data['forum_id'];
		}
		elseif (isset($data[0], $data[1]))
		{
			$userId = $data[0];
			$forumId = $data[1];
		}
		else
		{
			return false;
		}

		return array('xf_forum_watch' => $this->_getForumWatchModel()->getUserForumWatchByForumId($userId, $forumId));
	}

	protected function _getUpdateCondition($tableName)
	{
		return 'user_id = ' . $this->_db->quote($this->getExisting('user_id'))
		. ' AND forum_id = ' . $this->_db->quote($this->getExisting('forum_id'));
	}

	protected function _getForumWatchModel()
	{
		return $this->getModelFromCache('ForumWatch_Model_ForumWatch');
	}
}