<?php

class ForumWatch_Extend_DataWriter_User extends XFCP_ForumWatch_Extend_DataWriter_User
{
	protected function _postSave()
	{
		if ($this->isChanged('user_group_id') OR $this->isChanged('secondary_group_ids'))
		{
			$existingIds = array_map('intval', explode(',', $this->getExisting('secondary_group_ids')));
			$existingIds[] = intval($this->getExisting('user_group_id'));

			$newIds = array_map('intval', explode(',', $this->get('secondary_group_ids')));
			$newIds[] = intval($this->get('user_group_id')); 

			$addedIds = array();
			$removedIds = array();
			foreach ($existingIds as $existingId)
			{
				if ($existingId > 0 AND !in_array($existingId, $newIds))
				{
					$removedIds[] = $existingId;
				}
			}
			foreach ($newIds as $newId)
			{
				if ($newId > 0 AND !in_array($newId, $existingIds))
				{
					$addedIds[] = $newId;
				}
			}

			$this->getModelFromCache('ForumWatch_Model_ForumWatchGroup')->rebuildCacheGroupUserOneUser(
					intval($this->get('user_id')),
					$addedIds,
					$removedIds
			);
		}

		return parent::_postSave();
	}
}