<?php

class ForumWatch_Extend_Model_Forum extends XFCP_ForumWatch_Extend_Model_Forum
{
	public function canWatchForum(array $forum, &$errorPhraseKey = '', array $nodePermissions = null, array $viewingUser = null)
	{
		$this->standardizeViewingUserReferenceForNode($forum['node_id'], $viewingUser, $nodePermissions);

		if (empty($viewingUser['user_id']))
		{
			return false;
		}

		if ($this->getModelFromCache('ForumWatch_Model_ForumWatchGroup')->isGroupsWatchingForum(
				$viewingUser['user_group_id'],
				$viewingUser['secondary_group_ids'],
				$forum['node_id']))
		{
			return false;
		}

		return true;
	}

	public function prepareForumJoinOptions(array $fetchOptions)
	{
		$prepared = parent::prepareForumJoinOptions($fetchOptions);

		if (isset($fetchOptions['ForumWatch_watchUserId']))
		{
			if (!empty($fetchOptions['ForumWatch_watchUserId']))
			{
				$prepared['selectFields'] .= ',
						IF(forum_watch.user_id IS NULL, 0, 1) AS forum_is_watched';
				$prepared['joinTables'] .= '
						LEFT JOIN xf_forum_watch AS forum_watch
						ON (forum_watch.forum_id = forum.node_id
						AND forum_watch.user_id = ' . $this->_getDb()->quote($fetchOptions['ForumWatch_watchUserId']) . ')';
			}
			else
			{
				$prepared['selectFields'] .= ',
						0 AS forum_is_watched';
			}
		}

		return $prepared;
	}
}