<?php

class ForumWatch_Extend_Model_ThreadWatch extends XFCP_ForumWatch_Extend_Model_ThreadWatch
{
	public function sendNotificationToWatchUsersOnReply(array $reply, array $thread = null, array $noAlerts = array())
	{
		if ($reply['message_state'] != 'visible') return;

		$threadModel = $this->_getThreadModel();
		if (empty($thread))
		{
			$thread = $threadModel->getThreadById($reply['thread_id'], array(
					'join' => XenForo_Model_Thread::FETCH_FORUM
			));
		}
		if (empty($thread) OR $thread['discussion_state'] != 'visible') return;

		parent::sendNotificationToWatchUsersOnReply($reply, $thread, $noAlerts);

		$watchThreadUsers = $this->getUsersWatchingThread($thread['thread_id'], $thread['node_id']);
		$this->getModelFromCache('ForumWatch_Model_ForumWatch')->sendNotificationToWatchUsersOnReply($reply, $thread, array_keys($watchThreadUsers), $noAlerts);
	}

	public function getUsersWatchingThread($threadId, $nodeId)
	{
		// CACHE THE RESULT OF THE PARENT'S FUNCTION
		static $caches = array();

		$hash = "$threadId|$nodeId";
		if (!isset($caches[$hash]))
		{
			$caches[$hash] = parent::getUsersWatchingThread($threadId, $nodeId);
		}

		return $caches[$hash];
	}
}