<?php

class ForumWatch_Installer
{
	/* Start auto-generated lines of code. Change made will be overwriten... */

	protected static $_tables = array(
		'xf_forum_watch' => array(
			'createQuery' => 'CREATE TABLE IF NOT EXISTS `xf_forum_watch` (
				`user_id` INT(10) UNSIGNED NOT NULL
				,`forum_id` INT(10) UNSIGNED NOT NULL
				,`reply_subscribe` INT(10) UNSIGNED NOT NULL
				,`notification_method` INT(10) UNSIGNED NOT NULL DEFAULT \'0\'
				, PRIMARY KEY (`user_id`,`forum_id`)
				, INDEX `forum_id_reply_subscribe` (`forum_id`,`reply_subscribe`)
			) ENGINE = InnoDB CHARACTER SET utf8 COLLATE utf8_general_ci;',
			'dropQuery' => 'DROP TABLE IF EXISTS `xf_forum_watch`',
		),
		'xf_forum_watch_group' => array(
			'createQuery' => 'CREATE TABLE IF NOT EXISTS `xf_forum_watch_group` (
				`user_group_id` INT(10) UNSIGNED NOT NULL
				,`forum_id` INT(10) UNSIGNED NOT NULL
				,`reply_subscribe` INT(10) UNSIGNED NOT NULL
				,`notification_method` INT(10) UNSIGNED NOT NULL DEFAULT \'0\'
				, PRIMARY KEY (`user_group_id`,`forum_id`)
				, INDEX `forum_id_reply_subscribe` (`forum_id`,`reply_subscribe`)
			) ENGINE = InnoDB CHARACTER SET utf8 COLLATE utf8_general_ci;',
			'dropQuery' => 'DROP TABLE IF EXISTS `xf_forum_watch_group`',
		),
	);
	protected static $_patches = array();

	public static function install($existingAddOn, $addOnData)
	{
		$db = XenForo_Application::get('db');

		foreach (self::$_tables as $table)
		{
			$db->query($table['createQuery']);
		}

		foreach (self::$_patches as $patch)
		{
			$tableExisted = $db->fetchOne($patch['showTablesQuery']);
			if (empty($tableExisted))
			{
				continue;
			}

			$existed = $db->fetchOne($patch['showColumnsQuery']);
			if (empty($existed))
			{
				$db->query($patch['alterTableAddColumnQuery']);
			}
		}
		
		self::installCustomized($existingAddOn, $addOnData);
	}

	public static function uninstall()
	{
		$db = XenForo_Application::get('db');

		foreach (self::$_patches as $patch)
		{
			$tableExisted = $db->fetchOne($patch['showTablesQuery']);
			if (empty($tableExisted))
			{
				continue;
			}

			$existed = $db->fetchOne($patch['showColumnsQuery']);
			if (!empty($existed))
			{
				$db->query($patch['alterTableDropColumnQuery']);
			}
		}

		foreach (self::$_tables as $table)
		{
			$db->query($table['dropQuery']);
		}

		self::uninstallCustomized();
	}

	/* End auto-generated lines of code. Feel free to make changes below */

	public static function installCustomized($existingAddOn, $addOnData)
	{
		// customized install script goes here
	}

	public static function uninstallCustomized()
	{
		// customized uninstall script goes here
	}
	
}