<?php
class ForumWatch_Listener
{
	const MODEL_FETCH_OPTIONS_ACCEPT_CACHED = 'ForumWatch_acceptCached';

	public static function template_create(&$templateName, array &$params, XenForo_Template_Abstract $template)
	{
		if ($templateName == 'forum_view')
		{
			$template->preloadTemplate('forumwatch_forum_view');
		}
		elseif ($templateName == 'thread_view')
		{
			$template->preloadTemplate('forumwatch_thread_view');
		}
		elseif ($templateName == 'PAGE_CONTAINER')
		{
			$template->preloadTemplate('forumwatch_navigation_tabs_forums');
		}
	}

	public static function template_post_render($templateName, &$output, array &$containerData, XenForo_Template_Abstract $template)
	{
		if ($templateName == 'forum_view')
		{
			$ours = $template->create('forumwatch_forum_view', $template->getParams());
			$html = $ours->render();

			self::_injectHtml($html, $output);
		}
		elseif ($templateName == 'thread_view')
		{
			$ours = $template->create('forumwatch_thread_view', $template->getParams());
			$html = $ours->render();

			self::_injectHtml($html, $output);
		}
	}

	public static function template_hook($hookName, &$contents, array $hookParams, XenForo_Template_Abstract $template)
	{
		if ($hookName == 'navigation_tabs_forums')
		{
			$ours = $template->create('forumwatch_navigation_tabs_forums', $template->getParams());
			$html = $ours->render();

			$contents .= $html;
		}
	}

	public static function load_class($class, array &$extend)
	{
		static $classes = array(
				'XenForo_ControllerPublic_Forum',
				'XenForo_ControllerPublic_Thread',
				'XenForo_ControllerPublic_Watched',
				'XenForo_DataWriter_Discussion_Thread',
				'XenForo_DataWriter_User',
				'XenForo_Model_Forum',
				'XenForo_Model_Post',
				'XenForo_Model_ThreadWatch',
				'XenForo_Model_User',
		);

		if (in_array($class, $classes))
		{
			$extend[] = str_replace('XenForo_', 'ForumWatch_Extend_', $class);
		}
	}

	public static function file_health_check(XenForo_ControllerAdmin_Abstract $controller, array &$hashes)
	{
		$hashes += ForumWatch_FileSums::getHashes();
	}

	protected static function _injectHtml($html, &$target, $marker = '<!-- ForumWatch / Injection Marker -->')
	{
		$pos1 = strpos($html, $marker);
		if ($pos1 !== false) {
			$pos2 = strpos($html, $marker, $pos1 + 1);
			if ($pos2 !== false) {
				// both 2 markers have been found
				// we will now extract the marked text
				$markedText = trim(substr($html, $pos1 + strlen($marker), $pos2 - $pos1 - strlen($marker)));
				//var_dump(htmlentities($markedText));exit;
				if (!empty($markedText)) {
					$target = str_replace($markedText, $html, $target);
				}
			}
		}
	}
}